<script lang="ts" setup>
import { computed, onMounted, ref } from 'vue'
import UserApiV1 from '@/api/userApi'

const props = defineProps({
  userData: {
    type: Object,
    default: () => ({}),
  },
})

// const userData = reactive<{ id?: number, role?: string }>({});
const user = ref({ username: '', role: '' })
const valid = ref(false)
const saving = ref(false)
const isRequest = ref(false)
const requestMessage = ref('')
const isError = ref(false)

const optionsRole = ref([
  { value: null, title: 'Please select some item' },
  { value: 'USER', title: 'User' },
  { value: 'DEVELOPER', title: 'Developer' },
  { value: 'ADMIN', title: 'Administrator' },
])

const alertToggleVariant = computed(() => isError.value ? 'error' : 'success')
const alertToggleText = computed(() => isError.value ? 'Error!' : 'Success!')

const prepareOptionsRole = computed(() => {
  const roles = [...optionsRole.value]
  if (user.value.role.toLowerCase() === 'root')
    roles.push({ value: 'ROOT', title: 'Root (SuperAdmin)' })

  console.log('roles LIST', roles)

  return roles
})

const saveUser = async () => {
  // Need to restart isRequest value for show again if you close it
  isRequest.value = false
  saving.value = true
  try {
    const api = new UserApiV1()
    const response = await api.updateRoleUser(props.userData.role, props.userData.id)

    requestMessage.value = response.data.message
    isError.value = false
  }
  catch (error) {
    requestMessage.value = error.response.data.message
    isError.value = true
  }
  saving.value = false
  isRequest.value = true
}

onMounted(() => {
  user.value = JSON.parse(sessionStorage.getItem('user') || 'null') // Lee el user del localStorage;
  console.log('user.value', user.value)
  console.log('user.value.role', user.value.role)
})
</script>

<template>
  <VForm
    ref="form"
    @validation-change="valid = $event"
  >
    <VRow>
      <!-- 👉 Message Title and subtitle -->
      <VCol cols="12">
        <h6 class="text-h6 font-weight-medium">
          Account Details [{{ props.userData.username }}] - ({{ props.userData.id }})
        </h6>
        <p class="mb-0">
          Enter your Account Details
        </p>
      </VCol>
    </VRow>

    <VRow v-if="['admin', 'root'].includes(user.role.toLowerCase())">
      <!-- 👉 Message Title and subtitle -->
      <VCol
        cols="12"
        md="6"
      >
        <VSelect
          v-model="props.userData.role"
          label="User role"
          :items="prepareOptionsRole"
          :rules="[v => !!v || 'User role is required']"
          outlined
          dense
        />
      </VCol>
    </VRow>

    <VRow>
      <VCol cols="12">
        <VAlert
          v-if="isRequest"
          border="start"
          :border-color="alertToggleVariant"
          :color="alertToggleVariant"
          :type="alertToggleVariant"
          variant="tonal"
          dense
          closable
        >
          <VIcon
            icon="mdi-information"
            class="mr-2"
          />
          <strong>{{ alertToggleText }}</strong> {{ requestMessage }}
        </VAlert>
      </VCol>

      <VCol cols="12">
        <VBtn
          color="primary"
          class="mt-2"
          :loading="saving"
          :disabled="valid"
          @click="saveUser"
        >
          Save changes
        </VBtn>
      </VCol>
    </VRow>
  </VForm>
</template>

<style scoped>
</style>
